//---------------------------------------------------------------------------

#include <vcl.h>
#include <StrUtils.hpp>
#include <windows.h>
#pragma hdrstop

#include "Unit1.h"
#include "Cddb.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Cddb"
#pragma resource "*.dfm"
TForm1 *Form1;
Boolean BatchRead = false;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  for( int i = 0; i < Cddb->CdRoms.CdRomCount; i++ )
  {
    CbDrives->Items->Add( Cddb->CdRoms.CdRom[i].Description );
  }
  CbDrives->ItemIndex = 0;
  CbDrivesChange( Sender );  //Why won't Self work!?
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WMRead( TMessage &Message )
{
  TCddb* DaCDDB;
  DaCDDB = (TCddb*)Message.WParam;
  if( DaCDDB->State == CS_MATCH || DaCDDB->State == CS_MULTIMATCH )
  {
    DaCDDB->http_read();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CbDrivesChange(TObject *Sender)
{
  Cddb->ChangeActiveDrive( (unsigned char)CbDrives->ItemIndex );
  AnsiString DriveLetter = Cddb->GetActiveDriveLetter();
  DriveLetter += ":";
  Edit3->Text = DriveLetter;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
  char Letter;

  Letter = ((AnsiString)Edit3->Text)[1];
  Cddb->ChangeActiveDrive( Letter );
  CbDrives->ItemIndex = Cddb->GetActiveDrive();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerPort = Edit2->Text;
  Cddb->Connect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Cddb->Quit();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CddbDataExchange(TObject *Sender,
      AnsiString Status)
{
  Memo1->Lines->Add( Status );        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CddbStatusMessage(TObject *Sender,
      AnsiString Status)
{
  Memo1->Lines->Add( Status );        
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CddbMatch(TObject *Sender, TMatchArray &Matches,
      int &RightOne)
{
  RightOne = 0;

  if( BatchRead && ( Cddb->ServerType == HTTP ) )
  {
    //Here we make a HTTP Query - HTTP Read batch.
    PostMessage( Handle, WM_READ, (unsigned)Sender, 0 );
    BatchRead = false;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerAdditionalAddr = "/~cddb/cddb.cgi";
  Cddb->ServerType = HTTP;
  Cddb->ServerPort = "80";
  Cddb->http_query();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerAdditionalAddr = "/~cddb/cddb.cgi";
  Cddb->ServerType = HTTP;
  Cddb->ServerPort = "80";
  Cddb->http_read();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button24Click(TObject *Sender)
{
  BatchRead = true;
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerAdditionalAddr = "/~cddb/cddb.cgi";
  Cddb->ServerType = HTTP;
  Cddb->ServerPort = "80";
  Cddb->http_query();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
  int i = 0;
  AnsiString Entry = "";
  while( i < 512 && Cddb->CurrentEntry[i] != "" )
  {
    Entry += Cddb->CurrentEntry[i];
    Entry += "\r\n";
    i++;
  }

  AnsiString Text = "";
  Text.sprintf( "%d", i );
  MessageBox( Handle, Text.c_str(), "Info", 0 );
  MessageBox( Handle, Entry.c_str(), "Info", 0 );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button16Click(TObject *Sender)
{
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerAdditionalAddr = "/~cddb/cddb.cgi";
  Cddb->ServerType = HTTP;
  Cddb->ServerPort = "80";
  Cddb->http_sites();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)
{
  Cddb->SubmissionType = TEST;  //Change to SUBMIT to make real submissions
  Cddb->ServerAddr = Edit1->Text;
  Cddb->ServerAdditionalAddr = "/~cddb/cddb->cgi";
  Cddb->ServerType = HTTP;
  Cddb->ServerPort = "80";
  Cddb->http_submit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button23Click(TObject *Sender)
{
  TMatches Matches;
  TReplaceFlags Flags;
  AnsiString Text;

  Cddb->FindMatchesFromLocalCDDB( (int)&Matches );

  Text.sprintf( "'%s'\r\n'%s'", Matches[0].Category, Matches[0].DiscID );

  if( AnsiContainsStr( Text, "(null)" ) )
  {
    //AnsiReplaceStr( Text, "(null)", "" );  //This doesn't do anything?!
    Flags << rfReplaceAll;
    Text = StringReplace( Text, "(null)", "", Flags );
  }

  MessageBox( Handle, Text.c_str(), "Info", 0 );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button21Click(TObject *Sender)
{
  //If you want to read a SPECIFIC entry, you have
  //to enter a category retrieved with FindMatches
  Cddb->CDInfo->Category = '\0';
  if( Cddb->ReadInfoFromLocalCDDB() < 0 )
  {
      AnsiString Text;
      Text.sprintf( "%d", Cddb->ReadInfoFromLocalCDDB() );
      MessageBox( Handle, Text.c_str(), "Info", 0 );
      Cddb->RefreshDrives(); //If the file's not found, the TOC is lost. Reretrieve.
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button22Click(TObject *Sender)
{
  if( Cddb->SaveInfoToLocalCDDB() < 0 )
  {
    AnsiString Text;
    Text.sprintf( "%d", Cddb->SaveInfoToLocalCDDB() );
    MessageBox( Handle, Text.c_str(), "Info", 0 );
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
  Cddb->OnDataExchange = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
  Cddb->OnStatusMessage = NULL;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  // This shows some of the sites information
  TServerArray Servers;

  int i = 0;
  AnsiString Text = "";
  Servers[0] = *Cddb->Servers[0];

  while( i < 100 && Servers[i].Address != "" )
  {
    Servers[i] = *Cddb->Servers[i];

    Text.sprintf( "Addr: %s\r\nAdditionalAddr: %s\r\nPort: %s\r\nDescription: %s",
    Servers[i].Address, Servers[i].AdditionalAddress, Servers[i].Port,
    Servers[i].Location.Description );

    MessageBox( Handle, Text.c_str(), "Info", 0 );
    i++;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button19Click(TObject *Sender)
{
  // This clears the entry.

  for( int i = 0; i < 512; i++ )
  {
    Cddb->CurrentEntry[i] = "";
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button17Click(TObject *Sender)
{
  /*
   This parses CDDB.CDInfo and forms an entry from the data.
   The DLL parser, ParseEntry, can be used instead of the one
   used here.
  */

  Cddb->ParseCurrentEntry();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button20Click(TObject *Sender)
{
  // This is to test if
  // a) Creating an entry from an info record is working
  // b) CDDB.CDInfo can be edited

  //  Cddb.CDInfo.AddTrkInfo[0] := 'Bleech...this tune sucks.';

  //Cddb->FormEntry();
  Cddb->FormCurrentEntry();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button18Click(TObject *Sender)
{
  // This can be used to check whether parsing the entry has been successful

  AnsiString Text = "";
  TReplaceFlags Flags;

  Text = Text.sprintf( "%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n'%s'", Cddb->CDInfo->DiscID,
  Cddb->CDInfo->Artist, Cddb->CDInfo->Title, Cddb->CDInfo->Year, Cddb->CDInfo->Genre,
  Cddb->CDInfo->Category, Cddb->CDInfo->AddAlbumInfo, Cddb->CDInfo->Tracks[0], Cddb->CDInfo->AddTrkInfo[0] );

  if( AnsiContainsStr( Text, "(null)" ) )
  {
    //AnsiReplaceStr( Text, "(null)", "" );  //This doesn't do anything?!
    Flags << rfReplaceAll;
    Text = StringReplace( Text, "(null)", "", Flags );
  }

  MessageBox( Handle, Text.c_str(), "Info", 0 );
}
//---------------------------------------------------------------------------





void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Cddb->SendHello();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  Cddb->GetSites();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  Cddb->Query();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  Cddb->Read();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  Cddb->Proto();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button25Click(TObject *Sender)
{
  // I hope your connection settings are OK...
  if( Edit4->Text == "" || Edit5->Text == "" )
  {
    MessageBox( Handle, "SMTP mail server address or port is empty!", "Error", 0 );
    return;
  }

  Cddb->SubmissionType = TEST;
  Cddb->MailServerAddress = Edit4->Text;
  Cddb->MailServerPort = Edit5->Text; //"smtp";

  Cddb->smtp_submit();
}
//---------------------------------------------------------------------------
